/**
 * Copyright (c) 2000-2012 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.sb.model;

import com.liferay.portal.kernel.bean.AutoEscape;
import com.liferay.portal.model.BaseModel;
import com.liferay.portal.model.CacheModel;
import com.liferay.portal.service.ServiceContext;

import com.liferay.portlet.expando.model.ExpandoBridge;

import java.io.Serializable;

/**
 * The base model interface for the Inventory service. Represents a row in the &quot;inventory&quot; database table, with each column mapped to a property of this class.
 *
 * <p>
 * This interface and its corresponding implementation {@link com.sb.model.impl.InventoryModelImpl} exist only as a container for the default property accessors generated by ServiceBuilder. Helper methods and all application logic should be put in {@link com.sb.model.impl.InventoryImpl}.
 * </p>
 *
 * @author amifxw0
 * @see Inventory
 * @see com.sb.model.impl.InventoryImpl
 * @see com.sb.model.impl.InventoryModelImpl
 * @generated
 */
public interface InventoryModel extends BaseModel<Inventory> {
	/*
	 * NOTE FOR DEVELOPERS:
	 *
	 * Never modify or reference this interface directly. All methods that expect a inventory model instance should use the {@link Inventory} interface instead.
	 */

	/**
	 * Returns the primary key of this inventory.
	 *
	 * @return the primary key of this inventory
	 */
	public int getPrimaryKey();

	/**
	 * Sets the primary key of this inventory.
	 *
	 * @param primaryKey the primary key of this inventory
	 */
	public void setPrimaryKey(int primaryKey);

	/**
	 * Returns the inv ID of this inventory.
	 *
	 * @return the inv ID of this inventory
	 */
	public int getInvId();

	/**
	 * Sets the inv ID of this inventory.
	 *
	 * @param InvId the inv ID of this inventory
	 */
	public void setInvId(int InvId);

	/**
	 * Returns the item ID of this inventory.
	 *
	 * @return the item ID of this inventory
	 */
	public int getItemId();

	/**
	 * Sets the item ID of this inventory.
	 *
	 * @param ItemId the item ID of this inventory
	 */
	public void setItemId(int ItemId);

	/**
	 * Returns the u r l of this inventory.
	 *
	 * @return the u r l of this inventory
	 */
	@AutoEscape
	public String getURL();

	/**
	 * Sets the u r l of this inventory.
	 *
	 * @param URL the u r l of this inventory
	 */
	public void setURL(String URL);

	/**
	 * Returns the no of licence of this inventory.
	 *
	 * @return the no of licence of this inventory
	 */
	public int getNoOfLicence();

	/**
	 * Sets the no of licence of this inventory.
	 *
	 * @param NoOfLicence the no of licence of this inventory
	 */
	public void setNoOfLicence(int NoOfLicence);

	/**
	 * Returns the file type of this inventory.
	 *
	 * @return the file type of this inventory
	 */
	@AutoEscape
	public String getFileType();

	/**
	 * Sets the file type of this inventory.
	 *
	 * @param FileType the file type of this inventory
	 */
	public void setFileType(String FileType);

	public boolean isNew();

	public void setNew(boolean n);

	public boolean isCachedModel();

	public void setCachedModel(boolean cachedModel);

	public boolean isEscapedModel();

	public Serializable getPrimaryKeyObj();

	public void setPrimaryKeyObj(Serializable primaryKeyObj);

	public ExpandoBridge getExpandoBridge();

	public void setExpandoBridgeAttributes(ServiceContext serviceContext);

	public Object clone();

	public int compareTo(Inventory inventory);

	public int hashCode();

	public CacheModel<Inventory> toCacheModel();

	public Inventory toEscapedModel();

	public String toString();

	public String toXmlString();
}