/**
 * Copyright (c) 2000-2012 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.sb.model;

import com.liferay.portal.kernel.bean.AutoEscape;
import com.liferay.portal.model.BaseModel;
import com.liferay.portal.model.CacheModel;
import com.liferay.portal.service.ServiceContext;

import com.liferay.portlet.expando.model.ExpandoBridge;

import java.io.Serializable;

import java.util.Date;

/**
 * The base model interface for the Item service. Represents a row in the &quot;item&quot; database table, with each column mapped to a property of this class.
 *
 * <p>
 * This interface and its corresponding implementation {@link com.sb.model.impl.ItemModelImpl} exist only as a container for the default property accessors generated by ServiceBuilder. Helper methods and all application logic should be put in {@link com.sb.model.impl.ItemImpl}.
 * </p>
 *
 * @author amifxw0
 * @see Item
 * @see com.sb.model.impl.ItemImpl
 * @see com.sb.model.impl.ItemModelImpl
 * @generated
 */
public interface ItemModel extends BaseModel<Item> {
	/*
	 * NOTE FOR DEVELOPERS:
	 *
	 * Never modify or reference this interface directly. All methods that expect a item model instance should use the {@link Item} interface instead.
	 */

	/**
	 * Returns the primary key of this item.
	 *
	 * @return the primary key of this item
	 */
	public int getPrimaryKey();

	/**
	 * Sets the primary key of this item.
	 *
	 * @param primaryKey the primary key of this item
	 */
	public void setPrimaryKey(int primaryKey);

	/**
	 * Returns the item ID of this item.
	 *
	 * @return the item ID of this item
	 */
	public int getItemId();

	/**
	 * Sets the item ID of this item.
	 *
	 * @param ItemId the item ID of this item
	 */
	public void setItemId(int ItemId);

	/**
	 * Returns the num of this item.
	 *
	 * @return the num of this item
	 */
	@AutoEscape
	public String getNum();

	/**
	 * Sets the num of this item.
	 *
	 * @param Num the num of this item
	 */
	public void setNum(String Num);

	/**
	 * Returns the title of this item.
	 *
	 * @return the title of this item
	 */
	@AutoEscape
	public String getTitle();

	/**
	 * Sets the title of this item.
	 *
	 * @param Title the title of this item
	 */
	public void setTitle(String Title);

	/**
	 * Returns the artist of this item.
	 *
	 * @return the artist of this item
	 */
	@AutoEscape
	public String getArtist();

	/**
	 * Sets the artist of this item.
	 *
	 * @param Artist the artist of this item
	 */
	public void setArtist(String Artist);

	/**
	 * Returns the release date of this item.
	 *
	 * @return the release date of this item
	 */
	public Date getReleaseDate();

	/**
	 * Sets the release date of this item.
	 *
	 * @param ReleaseDate the release date of this item
	 */
	public void setReleaseDate(Date ReleaseDate);

	/**
	 * Returns the list price of this item.
	 *
	 * @return the list price of this item
	 */
	public double getListPrice();

	/**
	 * Sets the list price of this item.
	 *
	 * @param ListPrice the list price of this item
	 */
	public void setListPrice(double ListPrice);

	/**
	 * Returns the price of this item.
	 *
	 * @return the price of this item
	 */
	public double getPrice();

	/**
	 * Sets the price of this item.
	 *
	 * @param Price the price of this item
	 */
	public void setPrice(double Price);

	/**
	 * Returns the version of this item.
	 *
	 * @return the version of this item
	 */
	public int getVersion();

	/**
	 * Sets the version of this item.
	 *
	 * @param Version the version of this item
	 */
	public void setVersion(int Version);

	public boolean isNew();

	public void setNew(boolean n);

	public boolean isCachedModel();

	public void setCachedModel(boolean cachedModel);

	public boolean isEscapedModel();

	public Serializable getPrimaryKeyObj();

	public void setPrimaryKeyObj(Serializable primaryKeyObj);

	public ExpandoBridge getExpandoBridge();

	public void setExpandoBridgeAttributes(ServiceContext serviceContext);

	public Object clone();

	public int compareTo(Item item);

	public int hashCode();

	public CacheModel<Item> toCacheModel();

	public Item toEscapedModel();

	public String toString();

	public String toXmlString();
}