/**
 * Copyright (c) 2000-2012 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.sb.model;

import com.liferay.portal.model.BaseModel;
import com.liferay.portal.model.CacheModel;
import com.liferay.portal.service.ServiceContext;

import com.liferay.portlet.expando.model.ExpandoBridge;

import java.io.Serializable;

/**
 * The base model interface for the PurchaseItem service. Represents a row in the &quot;PurchaseItem&quot; database table, with each column mapped to a property of this class.
 *
 * <p>
 * This interface and its corresponding implementation {@link com.sb.model.impl.PurchaseItemModelImpl} exist only as a container for the default property accessors generated by ServiceBuilder. Helper methods and all application logic should be put in {@link com.sb.model.impl.PurchaseItemImpl}.
 * </p>
 *
 * @author amifxw0
 * @see PurchaseItem
 * @see com.sb.model.impl.PurchaseItemImpl
 * @see com.sb.model.impl.PurchaseItemModelImpl
 * @generated
 */
public interface PurchaseItemModel extends BaseModel<PurchaseItem> {
	/*
	 * NOTE FOR DEVELOPERS:
	 *
	 * Never modify or reference this interface directly. All methods that expect a purchase item model instance should use the {@link PurchaseItem} interface instead.
	 */

	/**
	 * Returns the primary key of this purchase item.
	 *
	 * @return the primary key of this purchase item
	 */
	public int getPrimaryKey();

	/**
	 * Sets the primary key of this purchase item.
	 *
	 * @param primaryKey the primary key of this purchase item
	 */
	public void setPrimaryKey(int primaryKey);

	/**
	 * Returns the purchase item ID of this purchase item.
	 *
	 * @return the purchase item ID of this purchase item
	 */
	public int getPurchaseItemId();

	/**
	 * Sets the purchase item ID of this purchase item.
	 *
	 * @param PurchaseItemId the purchase item ID of this purchase item
	 */
	public void setPurchaseItemId(int PurchaseItemId);

	/**
	 * Returns the po ID of this purchase item.
	 *
	 * @return the po ID of this purchase item
	 */
	public int getPoId();

	/**
	 * Sets the po ID of this purchase item.
	 *
	 * @param PoId the po ID of this purchase item
	 */
	public void setPoId(int PoId);

	/**
	 * Returns the item ID of this purchase item.
	 *
	 * @return the item ID of this purchase item
	 */
	public int getItemId();

	/**
	 * Sets the item ID of this purchase item.
	 *
	 * @param ItemId the item ID of this purchase item
	 */
	public void setItemId(int ItemId);

	/**
	 * Returns the quantity of this purchase item.
	 *
	 * @return the quantity of this purchase item
	 */
	public int getQuantity();

	/**
	 * Sets the quantity of this purchase item.
	 *
	 * @param Quantity the quantity of this purchase item
	 */
	public void setQuantity(int Quantity);

	/**
	 * Returns the unit price of this purchase item.
	 *
	 * @return the unit price of this purchase item
	 */
	public double getUnitPrice();

	/**
	 * Sets the unit price of this purchase item.
	 *
	 * @param UnitPrice the unit price of this purchase item
	 */
	public void setUnitPrice(double UnitPrice);

	public boolean isNew();

	public void setNew(boolean n);

	public boolean isCachedModel();

	public void setCachedModel(boolean cachedModel);

	public boolean isEscapedModel();

	public Serializable getPrimaryKeyObj();

	public void setPrimaryKeyObj(Serializable primaryKeyObj);

	public ExpandoBridge getExpandoBridge();

	public void setExpandoBridgeAttributes(ServiceContext serviceContext);

	public Object clone();

	public int compareTo(PurchaseItem purchaseItem);

	public int hashCode();

	public CacheModel<PurchaseItem> toCacheModel();

	public PurchaseItem toEscapedModel();

	public String toString();

	public String toXmlString();
}